/*#############################################################

Program Name    : ex1_LCD_HelloWorld
Author          : Grant Phillips
Date Modified   : 05/05/2016
Compiler        : ARMmbed
Tested On       : STM32F429ZI-Discovery

Description     : Example program that displays "Hello World!"
                  on the on-board 240 x 320 256K colors RGB
                  (QVGA) TFT LCD, using different fonts and 
                  colors.
                  Make sure to read LCD_DISCO_F429ZI class 
                  function explanation section on: 
                  http://controlsoft.nmmu.ac.za/ARMmbed/
                  STM32F429ZI-Discovery-Examples/QVGA-TFT-LCD

Requirements    : * STM32F429ZI-Discovery Board
              
Circuit         : * NONE

##############################################################*/

#include "mbed.h"
#include "LCD_DISCO_F429ZI.h"
#include "SDFileSystem.h"
#include "SWO.h"
#define Diameter 0.06
#define pie 3.141592654

LCD_DISCO_F429ZI lcd;       //Create a LCD_DISCO_F429ZI object
SWO_Channel SWO;    //create serial wire output channel called SWO


char WindDirection[100];
double analogvolt;

AnalogIn ain(PC_1);

float Dir;


void Wind_Direction();


void Wind_Direction()
{
    if((analogvolt >0.00) && (analogvolt <=0.21))
    {
        Dir = 112.5;
    }
    if((analogvolt >0.21) and (analogvolt <=0.27))
    {
        Dir = 67.5;
    }
    if((analogvolt >0.27) and (analogvolt <=0.30))
    {
        Dir = 90.0;
    }
    if((analogvolt >0.30) and (analogvolt <=0.41))
    {
        Dir = 157.5;
    }
    if((analogvolt >0.41) and (analogvolt <=0.60))
    {
        Dir = 135.0;
    }
    if((analogvolt >0.60) and (analogvolt <=0.79))
    {
        Dir = 202.5;
    }
    if((analogvolt >0.79) and (analogvolt <=0.93))
    {
        Dir = 180;
    }
    if((analogvolt >0.93) and (analogvolt <=1.31))
    {
        Dir = 22.5;
    }
    if((analogvolt >1.31) and (analogvolt <=1.49))
    {
        Dir = 45.0;
    }
    if((analogvolt >1.49) and (analogvolt <=1.93))
    {
        Dir = 247.5;
    }
    if((analogvolt >1.93) and (analogvolt <=2.03))
    {
        Dir = 225;
    }
    if((analogvolt >2.03) and (analogvolt <=2.26))
    {
        Dir = 337;
    }
    if((analogvolt >2.26) and (analogvolt <=2.53))
    {
        Dir = 0.00;
    }
    if((analogvolt >2.53) and (analogvolt <=2.67))
    {
        Dir = 232.5;
    }
    if((analogvolt >2.67) and (analogvolt <=2.86))
    {
        Dir = 315;
    }
    if((analogvolt >2.86) and (analogvolt <=3.05))
    {
        Dir = 270;
    }
}
int main() 
{      
    uint16_t analogval;
    
    
    while(1)
     {      
        //read the 16-bit value from the analog pin
        analogval = ain.read_u16();                     
        //calculate the voltage from the 16-bit value
        analogvolt = (double)analogval / 65535.0 * 3.3; 
        
                 Wind_Direction();

          lcd.SetTextColor(LCD_COLOR_WHITE);               
          lcd.SetBackColor(LCD_COLOR_BLACK);
          lcd.DisplayStringAtLine(0,(uint8_t*)" WIND STATION ");
          
          sprintf(WindDirection, "DIR     : %.2f", Dir,Dir);  
          lcd.DisplayStringAtLine(5, (uint8_t*)WindDirection);      //write the buf string to the LCD
          wait(0.1);   
       
 
 
    }
}
